import "../chunk-G2ADBYYC.js";
var timezone_default = {
  "enUS": [
    {
      name: "(UTC-12:00)International Date Line West",
      code: "001-12",
      offset: -12,
      tz: "Etc/GMT+12"
    },
    {
      name: "(UTC+13:00)Samoa",
      code: "002-11",
      offset: 14,
      tz: "Pacific/Apia"
    },
    {
      name: "(UTC-11:00)Coordinated Universal Time-11",
      code: "003-11",
      offset: -11,
      tz: "Etc/GMT+11"
    },
    {
      name: "(UTC-10:00)Hawaii",
      code: "004-10",
      offset: -10,
      tz: "Pacific/Honolulu"
    },
    {
      name: "(UTC-09:00)Alaska",
      code: "005-9",
      offset: -9,
      tz: "America/Anchorage"
    },
    {
      name: "(UTC-08:00)Pacific Time (US & Canada)",
      code: "006-8",
      offset: -8,
      tz: "America/Los_Angeles"
    },
    {
      name: "(UTC-08:00)Baja California",
      code: "007-8",
      offset: -8,
      tz: "America/Santa_Isabel"
    },
    {
      name: "(UTC-07:00)Chihuahua, La Paz, Mazatlan",
      code: "008-7",
      offset: -7,
      tz: "America/Chihuahua"
    },
    {
      name: "(UTC-07:00)Mountain Time (US & Canada)",
      code: "009-7",
      offset: -7,
      tz: "America/Denver"
    },
    {
      name: "(UTC-07:00)Arizona",
      code: "010-7",
      offset: -7,
      tz: "America/Phoenix"
    },
    {
      name: "(UTC-06:00)Guadalajara, Mexico City, Monterey",
      code: "011-6",
      offset: -6,
      tz: "America/Mexico_City"
    },
    {
      name: "(UTC-06:00)Saskatchewan",
      code: "012-6",
      offset: -6,
      tz: "America/Regina"
    },
    {
      name: "(UTC-06:00)Central Time (US & Canada)",
      code: "013-6",
      offset: -6,
      tz: "America/Chicago"
    },
    {
      name: "(UTC-06:00)Central America",
      code: "014-6",
      offset: -6,
      tz: "America/Guatemala"
    },
    {
      name: "(UTC-05:00)Bogota, Lima, Quito",
      code: "015-5",
      offset: -5,
      tz: "America/Bogota"
    },
    {
      name: "(UTC-05:00)Eastern Time (US & Canada)",
      code: "016-5",
      offset: -5,
      tz: "America/New_York"
    },
    {
      name: "(UTC-05:00)Indiana(East)",
      code: "017-5",
      offset: -5,
      tz: "America/Indiana/Indianapolis"
    },
    {
      name: "(UTC-04:30)Caracas",
      code: "018-4.5",
      offset: -4,
      tz: "America/Caracas"
    },
    {
      name: "(UTC-04:00)Atlantic Time (Canada)",
      code: "019-4",
      offset: -4,
      tz: "America/Halifax"
    },
    {
      name: "(UTC-04:00)Cuiaba",
      code: "020-4",
      offset: -4,
      tz: "America/Cuiaba"
    },
    {
      name: "(UTC-04:00)Georgetown, La Paz, Manaus, San Juan",
      code: "021-4",
      offset: -4,
      tz: "America/La_Paz"
    },
    {
      name: "(UTC-04:00)Santiago",
      code: "022-4",
      offset: -3,
      tz: "America/Santiago"
    },
    {
      name: "(UTC-04:00)Asuncion",
      code: "023-4",
      offset: -3,
      tz: "America/Asuncion"
    },
    {
      name: "(UTC-03:30)Newfoundland",
      code: "024-3.5",
      offset: -3.5,
      tz: "America/St_Johns"
    },
    {
      name: "(UTC-03:00)Brasilia",
      code: "025-3",
      offset: -3,
      tz: "America/Sao_Paulo"
    },
    {
      name: "(UTC-03:00)Buenos Aires",
      code: "026-3",
      offset: -3,
      tz: "America/Argentina/Buenos_Aires"
    },
    {
      name: "(UTC-03:00)Greenland",
      code: "027-3",
      offset: -3,
      tz: "America/Godthab"
    },
    {
      name: "(UTC-03:00)Cayenne, Fortaleza",
      code: "028-3",
      offset: -3,
      tz: "America/Cayenne"
    },
    {
      name: "(UTC-03:00)Montevideo",
      code: "029-3",
      offset: -3,
      tz: "America/Montevideo"
    },
    {
      name: "(UTC-11:00)Coordinated Universal Time-11",
      code: "030-2",
      offset: -11,
      tz: "Etc/GMT+11"
    },
    {
      name: "(UTC-02:00)Mid-Atlantic",
      code: "031-2",
      offset: -4,
      tz: "America/Halifax"
    },
    {
      name: "(UTC-01:00)Cape Verde Is",
      code: "032-1",
      offset: -1,
      tz: "Atlantic/Cape_Verde"
    },
    {
      name: "(UTC-01:00)Azores",
      code: "033-1",
      offset: -1,
      tz: "Atlantic/Azores"
    },
    {
      name: "(UTC)Dublin, Edinburgh, Lisbon, London",
      code: "034-0",
      offset: 0,
      tz: "Europe/London"
    },
    {
      name: "(UTC)Casablanca",
      code: "035-0",
      offset: 1,
      tz: "Africa/Casablanca"
    },
    {
      name: "(UTC)Monrovia, Reykjavik",
      code: "036-0",
      offset: 0,
      tz: "Atlantic/Reykjavik"
    },
    {
      name: "(UTC)Coordinated Universal Time",
      code: "037-0",
      offset: 0,
      tz: "Etc/GMT"
    },
    {
      name: "(UTC+01:00)Amsterdam, Berlin, Bern, Rome, Stockholm, Vienna",
      code: "038+1",
      offset: 1,
      tz: "Europe/Berlin"
    },
    {
      name: "(UTC+01:00)Belgrade, Bratislava, Budapest, Ljubljana, Prague",
      code: "039+1",
      offset: 1,
      tz: "Europe/Budapest"
    },
    {
      name: "(UTC+01:00)Brussels, Copenhagen, Madrid, Paris",
      code: "040+1",
      offset: 1,
      tz: "Europe/Paris"
    },
    {
      name: "(UTC+01:00)Sarajevo, Skopje, Warsaw, Zagreb",
      code: "041+1",
      offset: 1,
      tz: "Europe/Warsaw"
    },
    {
      name: "(UTC+01:00)Windhoek",
      code: "042+1",
      offset: 2,
      tz: "Africa/Windhoek"
    },
    {
      name: "(UTC+01:00)West Central Africa",
      code: "043+1",
      offset: 1,
      tz: "Africa/Lagos"
    },
    {
      name: "(UTC+02:00)Amman",
      code: "044+2",
      offset: 2,
      tz: "Asia/Amman"
    },
    {
      name: "(UTC+02:00)Beirut",
      code: "045+2",
      offset: 2,
      tz: "Asia/Beirut"
    },
    {
      name: "(UTC+02:00)Damascus",
      code: "046+2",
      offset: 2,
      tz: "Asia/Damascus"
    },
    {
      name: "(UTC+02:00)Harare, Pretoria",
      code: "047+2",
      offset: 2,
      tz: "Africa/Johannesburg"
    },
    {
      name: "(UTC+02:00)Helsinki, Kiev, Riga, Sofia, Tallinn, Vilnius",
      code: "048+2",
      offset: 2,
      tz: "Europe/Kiev"
    },
    {
      name: "(UTC+02:00)Cairo",
      code: "049+2",
      offset: 2,
      tz: "Africa/Cairo"
    },
    {
      name: "(UTC+02:00)Minsk",
      code: "050+2",
      offset: 3,
      tz: "Europe/Minsk"
    },
    {
      name: "(UTC+02:00)Athens, Bucharest, Istanbul",
      code: "051+2",
      offset: 3,
      tz: "Europe/Istanbul"
    },
    {
      name: "(UTC+02:00)Jerusalem",
      code: "052+2",
      offset: 2,
      tz: "Asia/Jerusalem"
    },
    {
      name: "(UTC+03:00)Baghdad",
      code: "053+3",
      offset: 3,
      tz: "Asia/Baghdad"
    },
    {
      name: "(UTC+03:00)Kuwait, Riyadh",
      code: "054+3",
      offset: 3,
      tz: "Asia/Riyadh"
    },
    {
      name: "(UTC+03:00)Moscow, St. Petersburg, Volgograd",
      code: "055+3",
      offset: 3,
      tz: "Europe/Moscow"
    },
    {
      name: "(UTC+03:00)Nairobi",
      code: "056+3",
      offset: 3,
      tz: "Africa/Nairobi"
    },
    {
      name: "(UTC+03:30)Teheran",
      code: "057+3.5",
      offset: 3.5,
      tz: "Asia/Tehran"
    },
    {
      name: "(UTC+04:00)Abu Dhabi, Muscat",
      code: "058+4",
      offset: 4,
      tz: "Asia/Dubai"
    },
    {
      name: "(UTC+04:00)Yerevan",
      code: "059+4",
      offset: 4,
      tz: "Asia/Yerevan"
    },
    {
      name: "(UTC+04:00)Baku",
      code: "060+4",
      offset: 4,
      tz: "Asia/Baku"
    },
    {
      name: "(UTC+04:00)Tbilisi",
      code: "061+4",
      offset: 4,
      tz: "Asia/Tbilisi"
    },
    {
      name: "(UTC+04:00)Port Louis",
      code: "062+4",
      offset: 4,
      tz: "Indian/Mauritius"
    },
    {
      name: "(UTC+04:30)Kabul",
      code: "063+4.5",
      offset: 4.5,
      tz: "Asia/Kabul"
    },
    {
      name: "(UTC+05:00)Tashkent",
      code: "064+5",
      offset: 5,
      tz: "Asia/Tashkent"
    },
    {
      name: "(UTC+05:00)Yekaterinburg",
      code: "065+5",
      offset: 5,
      tz: "Asia/Yekaterinburg"
    },
    {
      name: "(UTC+05:00)Islamabad, Karachi",
      code: "066+5",
      offset: 5,
      tz: "Asia/Karachi"
    },
    {
      name: "(UTC+05:30)Chennai, Kolkata, Mumbai, New Delhi",
      code: "067+5.5",
      offset: 5.5,
      tz: "Asia/Kolkata"
    },
    {
      name: "(UTC+05:30)Sri Jayawardenepura",
      code: "068+5.5",
      offset: 5.5,
      tz: "Asia/Colombo"
    },
    {
      name: "(UTC+05:45)Katmandu",
      code: "069+5.75",
      offset: 5.75,
      tz: "Asia/Kathmandu"
    },
    {
      name: "(UTC+06:00)Astana",
      code: "070+6",
      offset: 6,
      tz: "Asia/Almaty"
    },
    {
      name: "(UTC+06:00)Dhaka",
      code: "071+6",
      offset: 6,
      tz: "Asia/Dhaka"
    },
    {
      name: "(UTC+07:00)Novosibirsk",
      code: "072+6",
      offset: 7,
      tz: "Asia/Novosibirsk"
    },
    {
      name: "(UTC+06:30)Yangon(Rangoon)",
      code: "073+6.5",
      offset: 6.5,
      tz: "Asia/Yangon"
    },
    {
      name: "(UTC+07:00)Krasnoyarsk",
      code: "074+7",
      offset: 7,
      tz: "Asia/Krasnoyarsk"
    },
    {
      name: "(UTC+07:00)Bangkok, Hanoi, Jakarta",
      code: "075+7",
      offset: 7,
      tz: "Asia/Bangkok"
    },
    {
      name: "(UTC+08:00)Beijing, Chongqing, Hong Kong, Urumqi",
      code: "076+8",
      offset: 8,
      tz: "Asia/Shanghai"
    },
    {
      name: "(UTC+08:00)Kuala Lumpur, Singapore",
      code: "077+8",
      offset: 8,
      tz: "Asia/Singapore"
    },
    {
      name: "(UTC+08:00)Perth",
      code: "078+8",
      offset: 8,
      tz: "Australia/Perth"
    },
    {
      name: "(UTC+08:00)Taipei",
      code: "079+8",
      offset: 8,
      tz: "Asia/Taipei"
    },
    {
      name: "(UTC+08:00)Ulaanbaatar",
      code: "080+8",
      offset: 8,
      tz: "Asia/Ulaanbaatar"
    },
    {
      name: "(UTC+08:00)Irkutsk",
      code: "081+8",
      offset: 8,
      tz: "Asia/Irkutsk"
    },
    {
      name: "(UTC+09:00)Osaka, Sapporo, Tokyo",
      code: "082+9",
      offset: 9,
      tz: "Asia/Tokyo"
    },
    {
      name: "(UTC+09:00)Seoul",
      code: "083+9",
      offset: 9,
      tz: "Asia/Seoul"
    },
    {
      name: "(UTC+09:00)Yakutsk",
      code: "084+9",
      offset: 9,
      tz: "Asia/Yakutsk"
    },
    {
      name: "(UTC+09:30)Adelaide",
      code: "085+9.5",
      offset: 10.5,
      tz: "Australia/Adelaide"
    },
    {
      name: "(UTC+09:30)Darwin",
      code: "086+9.5",
      offset: 9.5,
      tz: "Australia/Darwin"
    },
    {
      name: "(UTC+10:00)Brisbane",
      code: "087+10",
      offset: 10,
      tz: "Australia/Brisbane"
    },
    {
      name: "(UTC+10:00)Vladivostok",
      code: "088+10",
      offset: 10,
      tz: "Asia/Vladivostok"
    },
    {
      name: "(UTC+10:00)Guam, Port Moresby",
      code: "089+10",
      offset: 10,
      tz: "Pacific/Port_Moresby"
    },
    {
      name: "(UTC+10:00)Hobart",
      code: "090+10",
      offset: 11,
      tz: "Australia/Hobart"
    },
    {
      name: "(UTC+10:00)Canberra, Melbourne, Sydney",
      code: "091+10",
      offset: 11,
      tz: "Australia/Sydney"
    },
    {
      name: "(UTC+11:00)Magadan",
      code: "092+11",
      offset: 11,
      tz: "Asia/Magadan"
    },
    {
      name: "(UTC+11:00)Solomon Is, New Caledonia",
      code: "093+11",
      offset: 11,
      tz: "Pacific/Guadalcanal"
    },
    {
      name: "(UTC+12:00)Auckland, Wellington",
      code: "094+12",
      offset: 13,
      tz: "Pacific/Auckland"
    },
    {
      name: "(UTC+12:00)Fiji",
      code: "095+12",
      offset: 13,
      tz: "Pacific/Fiji"
    },
    {
      name: "(UTC+12:00)Coordinated Universal Time+12",
      code: "096+12",
      offset: 12,
      tz: "Etc/GMT-12"
    },
    {
      name: "(UTC+13:00)Nuku`alofa",
      code: "097+13",
      offset: 13,
      tz: "Pacific/Tongatapu"
    }
  ],
  "zhCN": [
    {
      name: "(UTC-12:00)\u56FD\u9645\u65E5\u671F\u53D8\u66F4\u7EBF\u897F",
      code: "001-12",
      offset: -12,
      tz: "Etc/GMT+12"
    },
    {
      name: "(UTC+13:00) \u8428\u6469\u4E9A\u7FA4\u5C9B",
      code: "002-11",
      offset: 14,
      tz: "Pacific/Apia"
    },
    {
      name: "(UTC-11:00)\u534F\u8C03\u4E16\u754C\u65F6-11",
      code: "003-11",
      offset: -11,
      tz: "Etc/GMT+11"
    },
    {
      name: "(UTC-10:00)\u590F\u5A01\u5937",
      code: "004-10",
      offset: -10,
      tz: "Pacific/Honolulu"
    },
    {
      name: "(UTC-09:00)\u963F\u62C9\u65AF\u52A0",
      code: "005-9",
      offset: -9,
      tz: "America/Anchorage"
    },
    {
      name: "(UTC-08:00)\u592A\u5E73\u6D0B\u65F6\u95F4(\u7F8E\u56FD\u548C\u52A0\u62FF\u5927)",
      code: "006-8",
      offset: -8,
      tz: "America/Los_Angeles"
    },
    {
      name: "(UTC-08:00)\u4E0B\u52A0\u5229\u798F\u5C3C\u4E9A\u5DDE",
      code: "007-8",
      offset: -8,
      tz: "America/Santa_Isabel"
    },
    {
      name: "(UTC-07:00)\u5947\u74E6\u74E6\uFF0C\u62C9\u5DF4\u65AF\uFF0C\u9A6C\u8428\u7279\u5170",
      code: "008-7",
      offset: -7,
      tz: "America/Chihuahua"
    },
    {
      name: "(UTC-07:00)\u5C71\u5730\u65F6\u95F4(\u7F8E\u56FD\u548C\u52A0\u62FF\u5927)",
      code: "009-7",
      offset: -7,
      tz: "America/Denver"
    },
    {
      name: "(UTC-07:00)\u4E9A\u5229\u6851\u90A3",
      code: "010-7",
      offset: -7,
      tz: "America/Phoenix"
    },
    {
      name: "(UTC-06:00)\u74DC\u8FBE\u62C9\u54C8\u62C9\uFF0C\u58A8\u897F\u54E5\u57CE\uFF0C\u8499\u7279\u96F7",
      code: "011-6",
      offset: -6,
      tz: "America/Mexico_City"
    },
    {
      name: "(UTC-06:00)\u8428\u65AF\u5580\u5F7B\u6E29",
      code: "012-6",
      offset: -6,
      tz: "America/Regina"
    },
    {
      name: "(UTC-06:00)\u4E2D\u90E8\u65F6\u95F4(\u7F8E\u56FD\u548C\u52A0\u62FF\u5927)",
      code: "013-6",
      offset: -6,
      tz: "America/Chicago"
    },
    {
      name: "(UTC-06:00)\u4E2D\u7F8E\u6D32",
      code: "014-6",
      offset: -6,
      tz: "America/Guatemala"
    },
    {
      name: "(UTC-05:00)\u6CE2\u54E5\u5927\uFF0C\u5229\u9A6C\uFF0C\u57FA\u591A",
      code: "015-5",
      offset: -5,
      tz: "America/Bogota"
    },
    {
      name: "(UTC-05:00)\u4E1C\u90E8\u65F6\u95F4(\u7F8E\u56FD\u548C\u52A0\u62FF\u5927)",
      code: "016-5",
      offset: -5,
      tz: "America/New_York"
    },
    {
      name: "(UTC-05:00)\u5370\u5730\u5B89\u90A3\u5DDE(\u4E1C\u90E8)",
      code: "017-5",
      offset: -5,
      tz: "America/Indiana/Indianapolis"
    },
    {
      name: "(UTC-04:30)\u52A0\u62C9\u52A0\u65AF",
      code: "018-4.5",
      offset: -4,
      tz: "America/Caracas"
    },
    {
      name: "(UTC-04:00)\u5927\u897F\u6D0B\u65F6\u95F4(\u52A0\u62FF\u5927)",
      code: "019-4",
      offset: -4,
      tz: "America/Halifax"
    },
    {
      name: "(UTC-04:00)\u5E93\u4E9A\u5DF4",
      code: "020-4",
      offset: -4,
      tz: "America/Cuiaba"
    },
    {
      name: "(UTC-04:00)\u4E54\u6CBB\u6566\uFF0C\u62C9\u5DF4\u65AF\uFF0C\u9A6C\u7459\u65AF\uFF0C\u5723\u80E1\u5B89",
      code: "021-4",
      offset: -4,
      tz: "America/La_Paz"
    },
    {
      name: "(UTC-04:00)\u5723\u5730\u4E9A\u54E5",
      code: "022-4",
      offset: -3,
      tz: "America/Santiago"
    },
    {
      name: "(UTC-04:00)\u4E9A\u677E\u68EE",
      code: "023-4",
      offset: -3,
      tz: "America/Asuncion"
    },
    {
      name: "(UTC-03:30)\u7EBD\u82AC\u5170",
      code: "024-3.5",
      offset: -3.5,
      tz: "America/St_Johns"
    },
    {
      name: "(UTC-03:00)\u5DF4\u897F\u5229\u4E9A",
      code: "025-3",
      offset: -3,
      tz: "America/Sao_Paulo"
    },
    {
      name: "(UTC-03:00)\u5E03\u5B9C\u8BFA\u65AF\u827E\u5229\u65AF",
      code: "026-3",
      offset: -3,
      tz: "America/Argentina/Buenos_Aires"
    },
    {
      name: "(UTC-03:00)\u683C\u9675\u5170",
      code: "027-3",
      offset: -3,
      tz: "America/Godthab"
    },
    {
      name: "(UTC-03:00)\u5361\u5BB4\uFF0C\u798F\u5854\u96F7\u8428",
      code: "028-3",
      offset: -3,
      tz: "America/Cayenne"
    },
    {
      name: "(UTC-03:00)\u8499\u5F97\u7EF4\u7684\u4E9A",
      code: "029-3",
      offset: -3,
      tz: "America/Montevideo"
    },
    {
      name: "(UTC-11:00)\u534F\u8C03\u4E16\u754C\u65F6-11",
      code: "030-2",
      offset: -11,
      tz: "Etc/GMT+11"
    },
    {
      name: "(UTC-02:00)\u4E2D\u5927\u897F\u6D0B",
      code: "031-2",
      offset: -4,
      tz: "America/Halifax"
    },
    {
      name: "(UTC-01:00)\u4F5B\u5F97\u89D2\u7FA4\u5C9B",
      code: "032-1",
      offset: -1,
      tz: "Atlantic/Cape_Verde"
    },
    {
      name: "(UTC-01:00)\u4E9A\u901F\u5C14\u7FA4\u5C9B",
      code: "033-1",
      offset: -1,
      tz: "Atlantic/Azores"
    },
    {
      name: "(UTC)\u90FD\u67CF\u6797\uFF0C\u7231\u4E01\u5821\uFF0C\u91CC\u65AF\u672C\uFF0C\u4F26\u6566",
      code: "034-0",
      offset: 0,
      tz: "Europe/London"
    },
    {
      name: "(UTC)\u5361\u8428\u5E03\u5170\u5361",
      code: "035-0",
      offset: 1,
      tz: "Africa/Casablanca"
    },
    {
      name: "(UTC)\u8499\u7F57\u7EF4\u4E9A\uFF0C\u96F7\u514B\u96C5\u672A\u514B",
      code: "036-0",
      offset: 0,
      tz: "Atlantic/Reykjavik"
    },
    {
      name: "(UTC)\u534F\u8C03\u4E16\u754C\u65F6",
      code: "037-0",
      offset: 0,
      tz: "Etc/GMT"
    },
    {
      name: "(UTC+01:00)\u963F\u59C6\u65AF\u7279\u4E39\uFF0C\u67CF\u6797\uFF0C\u4F2F\u5C14\u5C3C\uFF0C\u7F57\u9A6C\uFF0C\u65AF\u5FB7\u54E5\u5C14\u6469\uFF0C\u7EF4\u4E5F\u7EB3",
      code: "038+1",
      offset: 1,
      tz: "Europe/Berlin"
    },
    {
      name: "(UTC+01:00)\u8D1D\u5C14\u683C\u83B1\u5FB7\uFF0C\u5E03\u62C9\u8FEA\u65AF\u62C9\u53D1\uFF0C\u5E03\u8FBE\u4F69\u65AF\uFF0C\u5362\u5E03\u5C14\u96C5\u90A3\uFF0C\u5E03\u62C9\u683C",
      code: "039+1",
      offset: 1,
      tz: "Europe/Budapest"
    },
    {
      name: "(UTC+01:00)\u5E03\u9C81\u585E\u5C14\uFF0C\u54E5\u672C\u54C8\u6839\uFF0C\u9A6C\u5FB7\u91CC\uFF0C\u5DF4\u9ECE",
      code: "040+1",
      offset: 1,
      tz: "Europe/Paris"
    },
    {
      name: "(UTC+01:00)\u8428\u62C9\u70ED\u7A9D\uFF0C\u65AF\u79D1\u666E\u91CC\uFF0C\u534E\u6C99\uFF0C\u8428\u683C\u52D2\u5E03",
      code: "041+1",
      offset: 1,
      tz: "Europe/Warsaw"
    },
    {
      name: "(UTC+01:00)\u6E29\u5F97\u548C\u514B",
      code: "042+1",
      offset: 2,
      tz: "Africa/Windhoek"
    },
    {
      name: "(UTC+01:00)\u4E2D\u975E\u897F\u90E8",
      code: "043+1",
      offset: 1,
      tz: "Africa/Lagos"
    },
    {
      name: "(UTC+02:00)\u5B89\u66FC",
      code: "044+2",
      offset: 2,
      tz: "Asia/Amman"
    },
    {
      name: "(UTC+02:00)\u8D1D\u9C81\u7279",
      code: "045+2",
      offset: 2,
      tz: "Asia/Beirut"
    },
    {
      name: "(UTC+02:00)\u5927\u9A6C\u58EB\u9769",
      code: "046+2",
      offset: 2,
      tz: "Asia/Damascus"
    },
    {
      name: "(UTC+02:00)\u54C8\u62C9\u96F7\uFF0C\u6BD4\u52D2\u9640\u5229\u4E9A",
      code: "047+2",
      offset: 2,
      tz: "Africa/Johannesburg"
    },
    {
      name: "(UTC+02:00)\u8D6B\u5C14\u8F9B\u57FA\uFF0C\u57FA\u8F85\uFF0C\u91CC\u52A0\uFF0C\u7D22\u975E\u4E9A\uFF0C\u5854\u6797\uFF0C\u7EF4\u5C14\u7EBD\u65AF",
      code: "048+2",
      offset: 2,
      tz: "Europe/Kiev"
    },
    {
      name: "UTC+02:00)\u5F00\u7F57",
      code: "049+2",
      offset: 2,
      tz: "Africa/Cairo"
    },
    {
      name: "(UTC+02:00)\u660E\u65AF\u514B",
      code: "050+2",
      offset: 3,
      tz: "Europe/Minsk"
    },
    {
      name: "(UTC+02:00)\u96C5\u5178\uFF0C\u5E03\u52A0\u52D2\u65AF\u7279\uFF0C\u4F0A\u65AF\u5766\u5E03\u5C14",
      code: "051+2",
      offset: 3,
      tz: "Europe/Istanbul"
    },
    {
      name: "(UTC+02:00)\u8036\u8DEF\u6492\u51B7",
      code: "052+2",
      offset: 2,
      tz: "Asia/Jerusalem"
    },
    {
      name: "(UTC+03:00)\u5DF4\u683C\u8FBE",
      code: "053+3",
      offset: 3,
      tz: "Asia/Baghdad"
    },
    {
      name: "(UTC+03:00)\u79D1\u5A01\u7279\uFF0C\u5229\u96C5\u5F97",
      code: "054+3",
      offset: 3,
      tz: "Asia/Riyadh"
    },
    {
      name: "(UTC+03:00)\u83AB\u65AF\u79D1\uFF0C\u5723\u5F7C\u5F97\u5821\uFF0C\u4F0F\u5C14\u52A0\u683C\u52D2",
      code: "055+3",
      offset: 3,
      tz: "Europe/Moscow"
    },
    {
      name: "(UTC+03:00)\u5185\u7F57\u6BD5",
      code: "056+3",
      offset: 3,
      tz: "Africa/Nairobi"
    },
    {
      name: "(UTC+03:30)\u5FB7\u9ED1\u5170",
      code: "057+3.5",
      offset: 3.5,
      tz: "Asia/Tehran"
    },
    {
      name: "(UTC+04:00)\u963F\u5E03\u624E\u6BD4\uFF0C\u9A6C\u65AF\u5580\u7279",
      code: "058+4",
      offset: 4,
      tz: "Asia/Dubai"
    },
    {
      name: "(UTC+04:00)\u57C3\u91CC\u6E29",
      code: "059+4",
      offset: 4,
      tz: "Asia/Yerevan"
    },
    {
      name: "(UTC+04:00)\u5DF4\u5E93",
      code: "060+4",
      offset: 4,
      tz: "Asia/Baku"
    },
    {
      name: "(UTC+04:00)\u7B2C\u6BD4\u5229\u65AF",
      code: "061+4",
      offset: 4,
      tz: "Asia/Tbilisi"
    },
    {
      name: "(UTC+04:00)\u8DEF\u6613\u6E2F",
      code: "062+4",
      offset: 4,
      tz: "Indian/Mauritius"
    },
    {
      name: "(UTC+04:30)\u5580\u5E03\u5C14",
      code: "063+4.5",
      offset: 4.5,
      tz: "Asia/Kabul"
    },
    {
      name: "(UTC+05:00)\u5854\u4EC0\u5E72",
      code: "064+5",
      offset: 5,
      tz: "Asia/Tashkent"
    },
    {
      name: "(UTC+05:00)\u53F6\u5361\u6377\u7433\u5821",
      code: "065+5",
      offset: 5,
      tz: "Asia/Yekaterinburg"
    },
    {
      name: "(UTC+05:00)\u4F0A\u65AF\u5170\u5821\uFF0C\u5361\u62C9\u5947",
      code: "066+5",
      offset: 5,
      tz: "Asia/Karachi"
    },
    {
      name: "(UTC+05:30)\u94A6\u5948\uFF0C\u52A0\u5C14\u5404\u7B54\uFF0C\u5B5F\u4E70\uFF0C\u65B0\u5FB7\u91CC",
      code: "067+5.5",
      offset: 5.5,
      tz: "Asia/Kolkata"
    },
    {
      name: "(UTC+05:30)\u65AF\u91CC\u52A0\u4E9A\u6E25\u767B\u666E\u62C9",
      code: "068+5.5",
      offset: 5.5,
      tz: "Asia/Colombo"
    },
    {
      name: "(UTC+05:45)\u52A0\u5FB7\u6EE1\u90FD",
      code: "069+5.75",
      offset: 5.75,
      tz: "Asia/Kathmandu"
    },
    {
      name: "(UTC+06:00)\u963F\u65AF\u5854\u7EB3",
      code: "070+6",
      offset: 6,
      tz: "Asia/Almaty"
    },
    {
      name: "(UTC+06:00)\u8FBE\u5361",
      code: "071+6",
      offset: 6,
      tz: "Asia/Dhaka"
    },
    {
      name: "(UTC+07:00)\u65B0\u897F\u4F2F\u5229\u4E9A",
      code: "072+6",
      offset: 7,
      tz: "Asia/Novosibirsk"
    },
    {
      name: "(UTC+06:30)\u4EF0\u5149",
      code: "073+6.5",
      offset: 6.5,
      tz: "Asia/Yangon"
    },
    {
      name: "(UTC+07:00)\u514B\u62C9\u65AF\u8BFA\u4E9A\u5C14\u65AF\u514B",
      code: "074+7",
      offset: 7,
      tz: "Asia/Krasnoyarsk"
    },
    {
      name: "(UTC+07:00)\u66FC\u8C37\uFF0C\u6CB3\u5185\uFF0C\u96C5\u52A0\u8FBE",
      code: "075+7",
      offset: 7,
      tz: "Asia/Bangkok"
    },
    {
      name: "(UTC+08:00)\u5317\u4EAC\uFF0C\u91CD\u5E86\uFF0C\u9999\u6E2F\u7279\u522B\u884C\u653F\u533A\uFF0C\u4E4C\u9C81\u6728\u9F50",
      code: "076+8",
      offset: 8,
      tz: "Asia/Shanghai"
    },
    {
      name: "(UTC+08:00)\u5409\u9686\u5761\uFF0C\u65B0\u52A0\u5761",
      code: "077+8",
      offset: 8,
      tz: "Asia/Singapore"
    },
    {
      name: "(UTC+08:00)\u73C0\u65AF",
      code: "078+8",
      offset: 8,
      tz: "Australia/Perth"
    },
    {
      name: "(UTC+08:00)\u53F0\u5317",
      code: "079+8",
      offset: 8,
      tz: "Asia/Taipei"
    },
    {
      name: "(UTC+08:00)\u4E4C\u5170\u5DF4\u6258",
      code: "080+8",
      offset: 8,
      tz: "Asia/Ulaanbaatar"
    },
    {
      name: "(UTC+08:00)\u4F0A\u5C14\u5E93\u8328\u514B",
      code: "081+8",
      offset: 8,
      tz: "Asia/Irkutsk"
    },
    {
      name: "(UTC+09:00)\u5927\u962A\uFF0C\u672D\u5E4C\uFF0C\u4E1C\u4EAC",
      code: "082+9",
      offset: 9,
      tz: "Asia/Tokyo"
    },
    {
      name: "(UTC+09:00)\u9996\u5C14",
      code: "083+9",
      offset: 9,
      tz: "Asia/Seoul"
    },
    {
      name: "(UTC+09:00)\u96C5\u5E93\u8328\u514B",
      code: "084+9",
      offset: 9,
      tz: "Asia/Yakutsk"
    },
    {
      name: "(UTC+09:30)\u963F\u5FB7\u83B1\u5FB7",
      code: "085+9.5",
      offset: 10.5,
      tz: "Australia/Adelaide"
    },
    {
      name: "(UTC+09:30)\u8FBE\u5C14\u6587",
      code: "086+9.5",
      offset: 9.5,
      tz: "Australia/Darwin"
    },
    {
      name: "(UTC+10:00)\u5E03\u91CC\u65AF\u73ED",
      code: "087+10",
      offset: 10,
      tz: "Australia/Brisbane"
    },
    {
      name: "(UTC+10:00)\u7B26\u62C9\u8FEA\u6C83\u65AF\u6258\u514B",
      code: "088+10",
      offset: 10,
      tz: "Asia/Vladivostok"
    },
    {
      name: "(UTC+10:00)\u5173\u5C9B\uFF0C\u83AB\u5C14\u5179\u6BD4\u6E2F",
      code: "089+10",
      offset: 10,
      tz: "Pacific/Port_Moresby"
    },
    {
      name: "(UTC+10:00)\u970D\u5DF4\u7279",
      code: "090+10",
      offset: 11,
      tz: "Australia/Hobart"
    },
    {
      name: "(UTC+10:00)\u582A\u57F9\u62C9\uFF0C\u58A8\u5C14\u672C\uFF0C\u6089\u5C3C",
      code: "091+10",
      offset: 11,
      tz: "Australia/Sydney"
    },
    {
      name: "(UTC+11:00)\u9A6C\u52A0\u4E39",
      code: "092+11",
      offset: 11,
      tz: "Asia/Magadan"
    },
    {
      name: "(UTC+11:00)\u6240\u7F57\u95E8\u7FA4\u5C9B\uFF0C\u65B0\u5580\u91CC\u591A\u5C3C\u4E9A",
      code: "093+11",
      offset: 11,
      tz: "Pacific/Guadalcanal"
    },
    {
      name: "(UTC+12:00)\u5965\u514B\u5170\uFF0C\u60E0\u7075\u987F",
      code: "094+12",
      offset: 13,
      tz: "Pacific/Auckland"
    },
    {
      name: "(UTC+12:00)\u6590\u6D4E",
      code: "095+12",
      offset: 13,
      tz: "Pacific/Fiji"
    },
    {
      name: "(UTC+12:00)\u534F\u8C03\u4E16\u754C\u65F6+12",
      code: "096+12",
      offset: 12,
      tz: "Etc/GMT-12"
    },
    {
      name: "(UTC+13:00)\u52AA\u5E93\u963F\u6D1B\u6CD5",
      code: "097+13",
      offset: 13,
      tz: "Pacific/Tongatapu"
    }
  ]
};
export {
  timezone_default as default
};
